<template>
  <v-layout column>
    <h1 class="text-center">
      Telzir
    </h1>
    <p class="text-center">
      Com o novo produto FaleMais da Telzir você adquire um plano e pode falar de graça até
      um determinado tempo (em minutos) e só paga os minutos excedentes.
    </p>
    <v-row v-if="showFormSimulation">
      <form-simulation ref="FormSimulationRef" />
    </v-row>
    <v-row v-if="showSimulation" class="d-flex justify-center flex-column">
      <table-info-simulation :values="valuesTableSimulation" />
    </v-row>
    <v-row class="d-flex justify-space-around mt-5">
      <v-btn
        v-if="showSimulation"
        class="ma-2 white"
        :loading="loading"
        :disabled="loading"
        color="green"
        @click="contact"
      >
        Contratar
      </v-btn>
      <v-btn
        v-if="showFormSimulation"
        class="ma-2 white"
        :loading="loading"
        :disabled="loading"
        color="purple"
        @click="simulation"
      >
        Calcular
      </v-btn>
    </v-row>
    <notifications group="error" position="bottom left" />
  </v-layout>
</template>

<script>
import FormSimulation from '~/components/FormSimulation'
import TableInfoSimulation from '~/components/TableInfoSimulation'

import { fetchSimulation } from '~/services/simulation'

export default {
  components: {
    FormSimulation,
    TableInfoSimulation
  },

  data: () => ({
    FormSimulationRef: null,

    formSimulation: {
      origin: '',
      destination: '',
      minutes: 0,
      plan: ''
    },

    loading: false,
    showFormSimulation: true,
    showSimulation: false,

    valueProgressCircular: 0,
    valuesTableSimulation: []
  }),

  computed: {
    isMobile () {
      return window.innerWidth < 768
    }
  },

  mounted () {
    this.FormSimulationRef = this.$refs.FormSimulationRef
  },

  methods: {
    async simulation () {
      this.$refs.FormSimulationRef.$v.$touch()
      if (this.$refs.FormSimulationRef.$v.$error) {
        this.notify(
          'error',
          'Não foi possível realizar a simulção',
          'Por favor, preencha os campos corretamente',
          'warn',
          6000
        )
      } else {
        this.loading = true
        this.showSimulation = false
        try {
          this.setDataFormSimulation()

          const response = await fetchSimulation(this.formSimulation)

          const { data: { simulation } } = response
          this.setValuesTableSimulation(simulation)

          this.showSimulation = true
        } catch (err) {
          this.notify(
            'error',
            'Não foi possível realizar a simulção',
            'Por favor, tente novamente ou entre em contato',
            'error',
            6000
          )
          this.showFormSimulation = true
        } finally {
          this.loading = false
        }
      }
    },

    setDataFormSimulation () {
      this.formSimulation = {
        origin: this.FormSimulationRef.originSelected,
        destination: this.FormSimulationRef.destinationSelected,
        minutes: this.FormSimulationRef.minutes,
        plan: this.FormSimulationRef.planSelected ? this.FormSimulationRef.planSelected : undefined
      }
    },

    setValuesTableSimulation (simulation) {
      this.valuesTableSimulation = []
      this.valuesTableSimulation.push(
        {
          origin: this.formSimulation.origin,
          destination: this.formSimulation.destination,
          minutes: this.formSimulation.minutes,
          plan: this.formSimulation.plan ? this.formSimulation.plan : '',
          withPlan: simulation.withPlan.price,
          withOutPlan: simulation.withOutPlan.price
        }
      )
    },

    contact () {
      let url

      if (this.isMobile) {
        url = `https://wa.me/55${75988027444}`
      } else {
        url = `https://web.whatsapp.com/send?phone=55${75988027444}`
      }

      window.open(url, '_blank')
    },

    notify (group, title, text, type, duration = 3000) {
      this.$notify({
        group,
        title,
        text,
        type,
        duration
      })
    }
  }
}
</script>

<style scoped>
</style>
